﻿Type=Activity
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

' NailShapetest  2017.07.23	version 1.0
'
' This is a small project showing the basics of a SQLite database
' The database has 5 columns:
' ColumnName			DataType
' ShapeID				INTEGER PRIMARY KEY
' ShapeNo				TEXT
' ShapeFilename			TEXT
' ShapeImage			BloB
' ShapeDescription		TEXT
'
' For the ID we use a PRIMARY KEY which is automatically incremented by one when a new entry is added.
' When we delete an entry the ID is lost
'
' Following functions are supported:
' Prev		shows the prvious entry
' Next		shows the next entry
'
' The database name, the table name and the column names are hard coded, to make the code better readable
' The user interface is kept very simple
' 2017.7.26 sucessfully to get every data from Existing SQLite database nail.db

' Written by : Andy  

Sub Process_Globals
	Dim SQL1 As SQL
	Dim CurrentIndex = -1 As Int			' index of the current entry
	Dim RowNumber = 0 As Int				' number of rows
End Sub

Sub Globals
	Dim Label1 As Label
	Dim fileDir As String : fileDir = "D:\test"
	Dim Listview1 As ListView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("newsLayout")
	Label1 = Listview1.SingleLineLayout.Label
	Listview1.SingleLineLayout.Label.Gravity = Gravity.CENTER
	Listview1.SingleLineLayout.ItemHeight = 5%y
	Listview1.SingleLineLayout.Label.Color = Colors.Gray
	Label1.TextSize = 12
	Label1.Height = 7%y
	Label1.Left = 0
	Label1.Gravity = Gravity.LEFT
	Label1.TextColor = Colors.Black
	Label1.Color = Colors.Gray
	' **********************************************************************************************************************************************
	'         initial SQLite 資料庫 news.db (用外面已建立的資料檔)
	' **********************************************************************************************************************************************
	Dim SQL1 As SQL																	'Remember to add SQL libraries through Windows-Libraries manager
	File.MakeDir(File.DirRootExternal, fileDir)		
	File.Copy(File.DirAssets, "news.db", File.DirRootExternal, "news.db")			'To define a External root Dir here is very important
	If FirstTime Then
		If File.Exists(File.DirRootExternal, "news.db") = False Then				'Remember to add nail.db in DirAsset and Layout "file"
			File.Copy(File.DirAssets, "news.db", File.DirRootExternal, "news.db")	'In our case we will always has a SQLite database nail.db
		End If																		'The nail.db will grow biger and biger
		SQL1.Initialize(File.DirRootExternal, "news.db", True)						'Each time we run the APP, the copy action will be processed
	End If																			'then initialized
	' **********************************************************************************************************************************************
	CurrentIndex = 0
	RowNumber = 10				'This parameter will be input from parameter file in the future
	BuildListView				'show the first entry

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		SQL1.Close		'if the user closes the program we close the database
	End If
End Sub

Sub BuildListView
	Dim Cursor1 As Cursor
	Dim ID As Int
	Dim A As String
	Dim B As String
	Dim Line As String
	For ID = 1 To 10													'get the ID for the given entry index
		Cursor1 = SQL1.ExecQuery("SELECT * FROM newstoday WHERE ID = " & ID)	'read the entry with the given ID. whole record put into cursor1
		Cursor1.Position = 0														'set the cursor
		A = Cursor1.GetString("ID")						'get & display the value of the shapeNo column from cursor1
		B = Cursor1.GetString("news")			'get & display the value of the shapeFilename column from cursor1
		Line = " " & A & ". " & B
		Listview1.AddSingleLine(Line)
	Next
	Cursor1.Close														'close the cursor, we don't need it anymore
End Sub

